module Display (idle, display) where
 
import Graphics.UI.GLUT
import Control.Monad
import Data.IORef
import Dodecahedron
import Points
 
display :: IORef GLfloat -> IORef (GLfloat, GLfloat) -> IORef GLfloat -> DisplayCallback
display angle pos zoom = do 
  clear [ColorBuffer, DepthBuffer] -- clear depth buffer, too
  clear [ColorBuffer]
  loadIdentity
  (x',y') <- get pos
  translate $ Vector3 x' y' 0
  preservingMatrix $ do
    a <- get angle
    z <- get zoom
    rotate a $ Vector3 1 0.5 0.2 -- changed y-component a bit to show off cube corners
    scale z z (z::GLfloat)
    forM_ (points 2) $ \(x,y,z,s) -> preservingMatrix $ do
      translate $ Vector3 x y z
      color $ Color3 ((s)::GLfloat) (s) (1) -- set outline color to black
      dodeca s   -- draw the outline
  swapBuffers
 
idle :: IORef GLfloat -> IORef GLfloat -> IdleCallback
idle angle delta = do
  d <- get delta
  angle $~! (+ d)
  postRedisplay Nothing

--    