module Dodecahedron where
 
import Graphics.UI.GLUT

vertex3f :: (GLfloat, GLfloat, GLfloat) -> IO ()
vertex3f (x, y, z) = vertex $ Vertex3 x y z
 
dodeca :: GLfloat -> IO ()
dodeca w = renderPrimitive LineStrip $ mapM_ vertex3f
      [ ( w , w ,-w),(w*p, 0, -w/p),(w*p,0,w/p),(w,w,w),(w/p, w*p, 0),
        ( w , w ,w),(0, w/p, w*p),(-w,w,w),(-w/p,w*p,0),(w/p, w*p, 0),
        ( w , w ,-w),(0, w/p, -w*p),(-w,w,-w),(-w/p,w*p,0),(w/p, w*p, 0),
        (-w/p,w*p,0),
        ( -w , w ,-w),(-w*p, 0, -w/p),(-w*p,0,w/p),(-w,w,w),(-w/p, w*p, 0),
        (-w,w,w),( 0 , w/p ,w*p),(0, -w/p, w*p),(-w,-w,w),(-w*p,0,w/p),
        ( -w , -w ,w),(-w/p, -w*p, 0),(-w,-w,-w),(-w*p, 0, -w/p),
        (-w,w,-w),( 0 , w/p ,-w*p),(0, -w/p, -w*p),(-w,-w,-w),(-w*p,0,-w/p),
        (-w,-w,-w),
        (0, -w/p, -w*p),(w,-w,-w),(w*p,0,-w/p),(w,w,-w),( 0 , w/p ,-w*p),
        (w,w,-w),
        (w*p, 0, -w/p),(w*p,0,w/p),(w,-w,w),(w/p, -w*p, 0),( w , -w ,-w),
        (w/p, -w*p, 0),(-w/p, -w*p, 0),
        (w/p, -w*p, 0),(w,-w,w),(0, -w/p, w*p)
        ] 
      where p = (1+(sqrt 5)) /2



pyra :: GLfloat -> IO ()
pyra w = renderPrimitive Polygon $ mapM_ vertex3f
  [ ( w, w, w), ( w, w,-w), ( w,-w,-w)]

cubeFrame :: GLfloat -> IO ()
cubeFrame w = renderPrimitive Lines $ mapM_ vertex3f
  [ ( w,-w, w), ( w, w, w),  ( w, w, w), (-w, w, w),
    (-w, w, w), (-w,-w, w),  (-w,-w, w), ( w,-w, w),
    ( w,-w, w), ( w,-w,-w),  ( w, w, w), ( w, w,-w),
    (-w, w, w), (-w, w,-w),  (-w,-w, w), (-w,-w,-w),
    ( w,-w,-w), ( w, w,-w),  ( w, w,-w), (-w, w,-w),
    (-w, w,-w), (-w,-w,-w),  (-w,-w,-w), ( w,-w,-w) ]

axes :: GLfloat -> IO ()
axes w = renderPrimitive Lines $ mapM_ vertex3f
 [(0,0,0), (w,0,0),(0,0,0),(0,w,0),(0,0,0),(0,0,w),
 (w/6,0,0), (w/6,w,0),(2*w/6,0,0), (2*w/6,w,0)]